/*
================================================================================
Function : Operation for SI446x
ַhttp://shop57165217.taobao.com
ߣ  ԭ  ں͵ӹ   ڰصӿƼ޹˾
TEL18615799380, e-mail: yihe_liyong@126.com
================================================================================
*/
#ifndef _BOARD_H_
#define _BOARD_H_

#include "iom8v.h"
#include "mytypedef.h"
#include "si446x.h"
#include "OLED.h"

/*Exchange a byte via the SPI bus*/
INT8U SPI_ExchangeByte( INT8U input );

/*Initialize the SPI bus*/
void SPI_Initial( void );

/*Initialize the other GPIOs of the board*/
void GPIO_Initial( void );

/*turn on the LED*/
#define LED_On( )       {PORTD &= ~0x03; DDRD |= 0x03; }

/*turn off the LED*/
#define LED_Off( )      {PORTD |= 0x03; DDRD |= 0x03; }

/*toggle the LED*/
#define LED_Toggle( )   {PORTD ^= 0x03; DDRD |= 0x03; }


//--------------operations for OLED module------------------------
#define OLED_CSN_H( )   {PORTB |= ( 1<<1 ); DDRB |= ( 1<<1 ); }
#define OLED_CSN_L( )   {PORTB &= ~( 1<<1 ); DDRB |= ( 1<<1 ); }

#define OLED_CMD_H( )   {PORTD |= ( 1<<7 ); DDRD |= ( 1<<7 ); }
#define OLED_CMD_L( )   {PORTD &= ~( 1<<7 ); DDRD |= ( 1<<7 ); }

#define OLED_RST_H( )   {PORTD |= ( 1<<6 ); DDRD |= ( 1<<6 ); }
#define OLED_RST_L( )   {PORTD &= ~( 1<<6 ); DDRD |= ( 1<<6 ); }

#define SI_CSN_LOW( )   {PORTB &= ~( 1<<2 ); DDRB |= ( 1<<2 ); }
#define SI_CSN_HIGH( )  {PORTB |= ( 1<<2 ); DDRB |= ( 1<<2 ); }

#define SI_SDN_LOW( )   {PORTC &= ~( 1<<4 ); DDRC |= ( 1<<4 ); }
#define SI_SDN_HIGH( )  {PORTC |= ( 1<<4 ); DDRC |= ( 1<<4 ); }

#endif //_BOARD_H_
/*
=================================================================================
------------------------------------End of FILE----------------------------------
=================================================================================
*/
