/*
================================================================================
Function : Operation for SI446x
ַhttp://shop57165217.taobao.com
ߣ  ԭ  ں͵ӹ   ڰصӿƼ޹˾
TEL18615799380, e-mail: yihe_liyong@126.com
================================================================================
*/
#include "board.h"

/*
=================================================================================
SPI_ExchangeByte( );
Function : Exchange a byte via the SPI bus
INTPUT   : input, The input byte
OUTPUT   : The output byte from SPI bus
=================================================================================
*/
INT8U SPI_ExchangeByte( INT8U input )
{
    SPDR = input;
	while ( !(SPSR & (1<<SPIF)) );
	return SPDR;
}
/*
=================================================================================
SPI_Initial( );
Function : Initialize the SPI bus
INTPUT   : None
OUTPUT   : None
=================================================================================
*/
void SPI_Initial( void )
{
    /*IO config*/
    PORTB |= ( 1<<3 ) | ( 1<<5 ) | ( 1<<2 );
    DDRB |= ( 1<<3 ) | ( 1<<5 ) | ( 1<<2 ) | ( 1<<4 );
    DDRB &= ~( 1<<4 );
    SPCR = (1<<SPE) | (1<<MSTR);
}
/*
=================================================================================
GPIO_Initial( );
Function : Initialize the other GPIOs of the board
INTPUT   : None
OUTPUT   : None
=================================================================================
*/
void GPIO_Initial( void )
{
    PORTB &= ~( 1<<0 );
    DDRB  |= ( 1<<0 );
}
/*
=================================================================================
------------------------------------End of FILE----------------------------------
=================================================================================
*/
