/* MAIN.C file
 *
 * Copyright (c) 2002-2005 STMicroelectronics
 */
#include "board.h"
#include "si446x.h"
#include "Oled.h"

INT8U  buffer[64] = {'0','0','0','0','0',0};
void main( void )
{
    volatile INT8U i, j, length, error;
    INT16U rx_conter = 0, itmp;

    SPI_Initial( );
    GPIO_Initial( );

    LCD_Init( );            //OLEDʼ
    LCD_Dis_Logo( );

    LCD_Dis_Str( 2,24,"AVR  board" );
    LCD_Dis_Str( 4,0,"yhmcu.taobao.com" );
    LCD_Dis_Str( 6,0,"SI446X:RX " );
    LCD_Dis_Str( 6, 80, (char*)buffer );
	
	SI_SDN_HIGH( );

    SI446X_RESET( );        //SI446X ģ鸴λ
    SI446X_CONFIG_INIT( );  //SI446X ģʼú
    SI446X_START_RX( 0, 0, PACKET_LENGTH,0,0,3 );

    while( 1 )
    {
        SI446X_INT_STATUS( buffer );
        if( buffer[3] & ( 1<<4 ) )
        {
            //յһݰ
            length = SI446X_READ_PACKET( buffer );
            

            //յ0-9ȽǷյȷ
            for( i = 0, error = 0; i < 10; i ++ )
            {
                if( buffer[i] != i )
                {
                    error = 1;      //
                    break;
                }
            }
            //ݳȺݶȷIF
            if( length == 10 && error == 0 )
            {
			 	LED_Toggle( );
                rx_conter ++;
                itmp = rx_conter;

                //Display the received count
                buffer[0] = ( itmp / 10000 ) + '0';
                itmp %= 10000;
                buffer[1] = ( itmp / 1000 ) + '0';
                itmp %= 1000;
                buffer[2] = ( itmp / 100 ) + '0';
                itmp %= 100;
                buffer[3] = ( itmp / 10 ) + '0';
                itmp %= 10;
                buffer[4] = itmp + '0';
                buffer[5] = 0;
                LCD_Dis_Str( 6, 80, (char*)buffer );

                //ӦΪ10-19
                for( i = 0; i < 10; i ++ )
                {
                    buffer[i] = i + 10;
                }
                //Ӧź,ʱȴ䷽ɹģʽ
                for( itmp = 0; itmp < 10000; itmp ++ );
                //䳤򶨳ģʽSI446X.H
#if PACKET_LENGTH == 0   //䳤ģʽ15ֽ,˴10ֽ
                SI446X_SEND_PACKET( buffer, 10, 0, 0 );
#else                    //ģʽȡPACKET_LENGTH,64
                SI446X_SEND_PACKET( buffer, PACKET_LENGTH, 0, 0 );
#endif

                do{  //ȴɣжϲ
                    SI446X_INT_STATUS( buffer );
                }while( !( buffer[3] & ( 1<<5 ) ) );
				
            }
            //صģʽȴź
            SI446X_START_RX( 0, 0, PACKET_LENGTH,0,0,3 );
        }
    }
}