/* MAIN.C file
 *
 * Copyright (c) 2002-2005 STMicroelectronics
 */
#include "mytypedef.h"
#include "si446x.h"
#include "OLED.h"
#include "board.h"

INT8U  buffer[64] = {'0','0','0','0','0',0};
void main( void )
{
    INT8U i, j, length, error;
    INT32U dly;
    INT16U tx_conter = 0, itmp;

    SPI_Initial( );         //SPI bus initialize
    GPIO_Initial( );        //GPIO initialize

    LCD_Init( );            //OLEDʼ
    LCD_Dis_Logo( );

	LED_On( );

    LCD_Dis_Str( 2,24,"AVR  board" );
    LCD_Dis_Str( 4,0,"yhmcu.taobao.com" );
    LCD_Dis_Str( 6,0,"SI446X:TX " );
    LCD_Dis_Str( 6, 80, (char*)buffer );

    SI446X_RESET( );        //SI446X ģ鸴λ
    SI446X_CONFIG_INIT( );  //SI446X ģʼú
    SI446X_START_RX( 0, 0, PACKET_LENGTH,0,0,3 );

	LED_Off( );
    while( 1 )
    {
        //0-9
        for( i = 0; i < 10; i ++ )      { buffer[i] = i; }
        //䳤򶨳ģʽSI446X.H
#if PACKET_LENGTH == 0   //䳤ģʽ15ֽ,˴10ֽ
        SI446X_SEND_PACKET( buffer, 10, 0, 0 );
#else                    //ģʽȡPACKET_LENGTH,64
        SI446X_SEND_PACKET( buffer, PACKET_LENGTH, 0, 0 );
#endif

        do{              //ȴɣжϲ
            SI446X_INT_STATUS( buffer );
        }while( !( buffer[3] & ( 1<<5 ) ) );
		if( buffer[3] == 0xFF && buffer[2] == 0xFF )	 { LED_On( );while(1); }

        //ģʽȴӦź
        SI446X_START_RX( 0, 0, PACKET_LENGTH,0,0,3 );
        dly = 1000;
        while( dly-- )
        {
            for( length = 0; length < 20; length ++ );
            SI446X_INT_STATUS( buffer );
            if( buffer[3] & ( 1<<4 ) )
            {
                length = SI446X_READ_PACKET( buffer );
                for( i = 0, error = 0; i < 10; i ++ )//жǷӦźΪ10-19
                {
                    if( buffer[i] != i + 10 )
                    {
                        error = 1;
                    }
                }
                if( length == 10 && error == 0 )  //10ֽӦź, 
                {
                    tx_conter ++;
                    itmp = tx_conter;
                    //Display the received count
                    buffer[0] = ( itmp / 10000 ) + '0';
                    itmp %= 10000;
                    buffer[1] = ( itmp / 1000 ) + '0';
                    itmp %= 1000;
                    buffer[2] = ( itmp / 100 ) + '0';
                    itmp %= 100;
                    buffer[3] = ( itmp / 10 ) + '0';
                    itmp %= 10;
                    buffer[4] = itmp + '0';
                    buffer[5] = 0;
                    LCD_Dis_Str( 6, 80, (char*)buffer );
                    break;
                }
            }
        }
        //ʱһʱ䣬ٴη
        for( dly = 0; dly < 5000; dly ++ );
        LED_On( );      //LED
        for( dly = 0;dly < 500; dly ++ );
        LED_Off( );     //ϨLED
    }
}